//--------------------------------------------------------------------------
#include <vcl.h>
#include <list.h>
#pragma hdrstop

#include "main.h"
#include "Unit1.h"
#include "repere.h"
#include "box.h"
#include "interval.h"
#include <fstream>
#include "Unit1.h"
int dimp=3;
int N_bissect=0;

double bmax=0.3; //pourcentage des points slectionns
double pixel_error=1;
double eps=0.005;
double percent_OK=0.2;


//---------------------------------------------------------------------------
#pragma package(smart_init)
//----------------------------------------------------------------------


extern TForm1 *Form1;
fstream Fout;
vector <double> x_im,y_im,d_im;
vector <box> Y;

//---------------------------------------------------------------------------
char* fgets2(FILE* f,char* line)   //Afin d'ignorer les lignes qui commencent par %
{ char* r;
  do   { r=fgets(line,256,f);}  while ((line[0]=='%')&&(r!= NULL));
  return r;
}
//---------------------------------------------------------------------------
void readdata()
{   x_im.clear();
    y_im.clear();
    FILE *fx,*fy,*fd;
    char linex[256];
    char liney[256];
    char lined[256];
    //a.inf+(a.sup-a.inf)*rand()/RAND_MAX
    fx = fopen("x.txt","r");
    fy = fopen("y.txt","r");
    fd = fopen("d.txt","r");
    while ((fgets2(fx,linex) != NULL)&&(fgets2(fy,liney) != NULL)&&(fgets2(fd,lined) != NULL))
        {   double x1,y1,d1;
            double b=1.0*rand()/RAND_MAX;
            if (b<bmax)
            {
            sscanf(linex,"%lf",&x1);
            sscanf(liney,"%lf",&y1);
            sscanf(lined,"%lf",&d1);
            d1=d1*M_PI/180;
            x_im.push_back(x1);
            y_im.push_back(y1);
            d_im.push_back(d1);
            }
        }
    int Nx=x_im.size();

//    while (fgets2(fy,line) != NULL)
//        {   //double y1;
//            sscanf(line,"%lf",&y1);
//            y_im.push_back(y1);
//        }
    int Ny=x_im.size();
    fclose(fx);
    fclose(fy);
    fclose(fd);
    for (int i=0;i<Nx;i++)
        {   box Y1(3);
            Y1[1]=0.01*(x_im[i]+interval(-pixel_error,pixel_error));
            Y1[2]=0.01*(y_im[i]+interval(-pixel_error,pixel_error));
            Y1[3]=d_im[i]+interval(-0.18,0.18);
            Y1[2]=Form1->ymax-Y1[2];
            Y.push_back(Y1);
         }
    int NY=Y.size();
}

void DrawImage(repere& R)
{ for (int i=0;i<Y.size();i++)
       R.DrawBox(Y[i],clBlue,clRed,bsSolid);
  R.image->Refresh();
} ;

//----------------------------------------------------------------------
bool Contract(box& P)
{   // P=(x,y,r)
    vector<box> L;
    box Pi;
    for  (int i=0;i<Y.size();i++)
     	{       Pi=P;
                box Yc=Y[i];
                interval y1=Yc[1];
                interval y2=Yc[2];
                // (P[1]-xim)^2+(P[2]-yim)^2 = r^2
                interval dx=Pi[1]-y1;
                interval dy=Pi[2]-y2;
                interval dx2=Sqr(dx);
                interval dy2=Sqr(dy);
                interval dx2pdy2=dx2+dy2;
                interval r2=Sqr(Pi[3]);
                Cegal(r2,dx2pdy2);

                //-----
                interval y3=Yc[3];
                interval g1=Cos(y3);
                interval g2=Sin(y3);
                interval a1=dx*g2;
                interval a2=dy*g1;
                Cegal(a1,a2);
                Cprod(a1,dx,g2,-1);
                Cprod(a2,dy,g1,-1);


                //-----


                Csqr(r2,Pi[3],-1);
                Cplus(dx2pdy2,dx2,dy2,-1);
                Csqr(dy2,dy,-1);
                Csqr(dx2,dx,-1);
                Cmoins(dx,Pi[1],y1,-1);
                Cmoins(dy,Pi[2],y2,-1);
                L.push_back(Pi);
        }   ;
     //vector<box> Lv=L;
     int nn=ceil(percent_OK*Y.size());
     C_q_in(P,nn,L);
}


void SIVIA(box& P0)
{   box P;
    Form1->R1.image->Refresh();
    list<box> L;
    L.push_back(P0);
    while (!L.empty())
    { P=L.front();
      Form1->R1.DrawCadre(P,clBlue,psSolid,1,2,1);
      L.pop_front();
      bool sortie=false;
      while (!sortie)
       {  box Pold(P);
          Contract(P);
          if (P.IsEmpty())           sortie=true;
          if (decrease(Pold,P)<0.05) sortie=true;
       }
      if (!P.IsEmpty())
      {  if (P.Width()<eps)
            {     Form1->R1.DrawBox(P,clRed,clRed,bsSolid,1,2);
                  double xe=Center(P[1]);
                  double ye=Center(P[2]);
                  double re=Center(P[3]);
                  Form1->R2.DrawCircle (xe,ye,re,clWhite,clBlue,1);
                  Form1->R2.image->Refresh();
            }
         else  {   box P1,P2;
                   Bisect(P,P1,P2);
                   N_bissect++;
                   L.push_back(P1);
                   L.push_back(P2);
               }
      }
    }
    L.clear();
} ;




//----------------------------------------------------------------------
void TForm1::GO(double xmin,double xmax,double ymin,double ymax)
{ Edit1->Text="Inside GO";
  Fout.open("info.txt",fstream::out);
  Fout <<"Dbut\n"<<"\n";
  readdata();
  DrawImage(Form1->R2);
      //AnsiString s="";
      //s=s+"t = "+t+"";
      //Edit1->Text=s+"";
      //Edit1->Repaint();
  box P(3);
  P[1]=interval(xmin,xmax);
  P[2]=interval(ymin,ymax);
  P[3]=interval(0.0,10000);
//    P[3]=interval(0.337,0.338);
  //Form1->R2.DrawEllipse2(3.15,6,1.10,0.70,-0.45,clGreen);
  SIVIA(P);
  Fout << "N_bissect = " <<N_bissect<<"\n";

  Fout.close();
} ;

//----------------------------------------------------------------------


